%define releasebase 19

# allow --with[out] <feature> at rpm command line build
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
#pick the target
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%define targetbase Limulus
%endif

Name: cluster-admin-support
Version:1.1
Group: %{targetbase}/Admin
Release: %{releasebase}.%{targetbase}
Summary: Extra config for parallel remote shell program.
License: none
URL: http://sourceforge.net/projects/pdsh/
Group: System Environment/Base
Source: %{name}-%{version}.tgz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}
Requires: whatsup pdsh
Vendor: Basement-Supercomputing.com

%description
Extra support scripts and configuration for Basement Supercomputer cluster administration.
Adds checknodes.sh script (used whats-up pingd) and sets cron.d file. Adds ssh key generation
fro new users. Adds ganglia temperature module. Adds shutdown scrpt for nodes.
Adds limulus-node-temp.sh, fancontrol rc script, /etc/fancontrol file for Limulus machines. 
Note: fancontrol is for Limulus machines built by Basement Supercomputing. If you build
your own machine with different fans, makes sure you calibarate your fans!
%prep
%setup 

%build

%install

/bin/mkdir -p %{buildroot}/etc/warewulf/.%{targetbase}

cp  checknodes.sh  %{buildroot}/etc/warewulf/.%{targetbase}
chmod go-x %{buildroot}/etc/warewulf/.%{targetbase}/checknodes.sh
cp  gather.sh  %{buildroot}/etc/warewulf/.%{targetbase}
chmod go-x %{buildroot}/etc/warewulf/.%{targetbase}/gather.sh
cp  generate-ssh-keys.sh  %{buildroot}/etc/warewulf/.%{targetbase}

sed  --in-place 's/FILLINBASE/%{targetbase}/' %{buildroot}/etc/warewulf/.%{targetbase}/checknodes.sh
sed  --in-place 's/FILLINBASE/%{targetbase}/' %{buildroot}/etc/warewulf/.%{targetbase}/generate-ssh-keys.sh
# add profile.d so WCOLL get set on login
/bin/mkdir -p  %{buildroot}/etc/profile.d
cat <<EOF > %{buildroot}/etc/profile.d/pdsh.sh
if [ -e /etc/warewulf/.%{targetbase} ]; then
  export WCOLL=/etc/warewulf/.%{targetbase}/up-nodes
fi
EOF

cat <<EOF > %{buildroot}/etc/profile.d/pdsh.csh
if(  -e /etc/warewulf/.%{targetbase} ) then
setenv WCOLL /etc/warewulf/.%{targetbase}/up-nodes
endif
EOF
# add cron script to check nodes (uses whats-up)
/bin/mkdir -p %{buildroot}/etc/cron.d
cat <<EOF> %{buildroot}/etc/cron.d/pdsh-node-check
*/1  *  *  *  * root /etc/warewulf/.%{targetbase}/checknodes.sh &> /dev/null
EOF
# add Ganglia temperature module
mkdir -p  %{buildroot}/opt/etc/ganglia
cp  gtemp.sh  %{buildroot}/opt/etc/ganglia/gtemp.sh
chmod go-x %{buildroot}/opt/etc/ganglia/gtemp.sh

# set cron to report temps once each minute
/bin/mkdir -p %{buildroot}/etc/cron.d
cat <<EOF> %{buildroot}/etc/cron.d/report-ganglia-temp
*/1  *  *  *  * root /opt/etc/ganglia/gtemp.sh &> /dev/null
EOF

%if "%{targetbase}" == "Limulus"
  # add node shutdown and fan control scripts for Limulus systems
  /bin/mkdir -p  %{buildroot}/etc/limfanctl/
  /bin/cp  etc/limfanctl/limfanctl.conf %{buildroot}/etc/limfanctl/limfanctl.conf
  
  /bin/mkdir -p  %{buildroot}/etc/rc.d/init.d/
  /bin/cp  init.d/shutdown-nodes %{buildroot}/etc/rc.d/init.d/shutdown-nodes
  /bin/chmod 755 %{buildroot}/etc/rc.d/init.d/shutdown-nodes

  /bin/cp  init.d/limfanctl %{buildroot}/etc/rc.d/init.d/limfanctl
  /bin/chmod 755 %{buildroot}/etc/rc.d/init.d/limfanctl

  /bin/mkdir -p %{buildroot}/usr/sbin
  /bin/cp sbin/limulus-node-temp %{buildroot}/usr/sbin
  /bin/chmod 744 %{buildroot}/usr/sbin/limulus-node-temp
    
  /bin/cp sbin/turbo-off  %{buildroot}/usr/sbin
  /bin/cp sbin/turbo-on %{buildroot}/usr/sbin
  /bin/cp sbin/turbo-status %{buildroot}/usr/sbin
  /bin/chmod 744 %{buildroot}/usr/sbin/turbo-*
  
  /bin/cp sbin/node-turbo-off  %{buildroot}/usr/sbin
  /bin/cp sbin/node-turbo-on %{buildroot}/usr/sbin
  /bin/cp sbin/node-turbo-status %{buildroot}/usr/sbin
  /bin/chmod 744 %{buildroot}/usr/sbin/node-turbo-*
  
  /bin/cp sbin/node-governor-set %{buildroot}/usr/sbin
  /bin/cp sbin/node-governor-status %{buildroot}/usr/sbin
  /bin/chmod 744 %{buildroot}/usr/sbin/node-governor-*

  /bin/cp sbin/governor-set %{buildroot}/usr/sbin
  /bin/cp sbin/governor-status %{buildroot}/usr/sbin
  /bin/chmod 744 %{buildroot}/usr/sbin/governor-*

# fancontrol files are selected on install because they vary by motherboard, so copy all
  /bin/mkdir -p %{buildroot}/etc/warewulf/.%{targetbase}/limfancontrol
  /bin/cp etc/fancontrol.* %{buildroot}/etc/warewulf/.%{targetbase}/limfancontrol
  /bin/cp  run-npb-with-temps.sh  %{buildroot}/etc/warewulf/.%{targetbase}
  /bin/chmod 755 %{buildroot}/etc/warewulf/.%{targetbase}/run-npb-with-temps.sh

%endif

%post
# If Limulus add fancontrol and start fans
if [ -e /etc/rc.d/init.d/limfanctl ] ; then
  # Select correct fancontrol file
  MOTHERBOARD=`dmidecode |grep -A 4 "Base Board"|grep Product|sed 's/\tProduct Name: //'|sed 's/ /_/g'`
  case $MOTHERBOARD in
    GRYPHON_Z87)
      /bin/cp /etc/warewulf/.%{targetbase}/limfancontrol/fancontrol.GRYPHON_Z87 /etc/fancontrol
      ;;
    Z170M-PLUS)
      /bin/cp /etc/warewulf/.%{targetbase}/limfancontrol/fancontrol.Z170M-PLUS  /etc/fancontrol      
      ;;
    PRIME_Z270M-PLUS)
      /bin/cp /etc/warewulf/.%{targetbase}/limfancontrol/fancontrol.Z170M-PLUS  /etc/fancontrol      
      ;;
    *)
      echo "WARNING: Unsupported Limulus Motherboard. Node fancontrol will NOT work."
      echo "Contact Basement Supercomputing"
      ;;
  esac
  # turn on shutdown and limfanctl  if  installed
  if [ -e /etc/rc.d/init.d/shutdown-nodes ] ; then
    /sbin/chkconfig --add shutdown-nodes
  fi
  if [ -f /etc/rc.d/init.d/limfanctl ] ; then
    /sbin/chkconfig --add limfanctl
  fi
  # restart or start limfanctl
  /etc/init.d/limfanctl restart
  /etc/init.d/shutdown-nodes restart
fi
# add SSH keygen for new users
/bin/mkdir -p /etc/skel
cat <<EOF>> /etc/skel/.bashrc
/etc/warewulf/.%{targetbase}/generate-ssh-keys.sh
EOF
cat <<EOF>>/etc/skel/.cshrc
/etc/warewulf/.%{targetbase}/generate-ssh-keys.sh
EOF

%clean
if [ $RPM_BUILD_ROOT != "/" ]; then
  rm -rf $RPM_BUILD_ROOT
fi
%preun
# remove shutdown-nodes and limfanctl only on uninstall
if [ $1 = 0 ]; then
  if [ -f /etc/rc.d/init.d/shutdown-nodes ] ; then
    /sbin/chkconfig --del shutdown-nodes
  fi
  if [ -f /etc/rc.d/init.d/limfanctl ] ; then
    /sbin/chkconfig --del limfanctl
  fi
fi

%postun
if [ $1 = 0 ]; then
  # remove /etc/skel entries
  sed --in-place '/\/etc\/warewulf\/\.%{targetbase}\/generate-ssh-keys\.sh/d' /etc/skel/.cshrc
  sed --in-place '/\/etc\/warewulf\/\.%{targetbase}\/generate-ssh-keys\.sh/d' /etc/skel/.bashrc
  # remove the fancontrol file copied in post
  /bin/rm /etc/fancontrol
fi

%files
%defattr(-,root,root)
/etc/profile.d
/etc/cron.d/pdsh-node-check
/etc/cron.d/report-ganglia-temp
/etc/warewulf
/opt/etc/ganglia
%if "%{targetbase}" == "Limulus"
/etc/rc.d/init.d/shutdown-nodes
/etc/rc.d/init.d/limfanctl
/etc/limfanctl/limfanctl.conf
/usr/sbin/limulus-node-temp
/usr/sbin/turbo-off
/usr/sbin/turbo-on
/usr/sbin/turbo-status
/usr/sbin/node-turbo-off
/usr/sbin/node-turbo-on
/usr/sbin/node-turbo-status
/usr/sbin/governor-set
/usr/sbin/governor-status
/usr/sbin/node-governor-set
/usr/sbin/node-governor-status
%endif

%changelog
* Mon Jun 26 2017  Douglas Eadline <deadline@basement-supercomputing.com>
- updated fancontrol for PRIME_Z270M-PLUS motherboard
* Sun Jan 29 2017  Douglas Eadline <deadline@basement-supercomputing.com>
- To ensure nodes always shutdown, make pdsh in shutdown-nodes run as separate process, so it cannot freeze shutdown
* Tue Dec 20 2016 Douglas Eadline <deadline@basement-supercomputing.com>
- fixed pgrep in limulus-node-temp (use -f option with full path) 
* Thu Mar 23 2016 Douglas Eadline <deadline@basement-supercomputing.com>
- increase robustness of limfanctl by addeding sshd-check for nodes 
- and test to ensure lm_sensors is running on nodes in limulus-node-temp
* Mon Dec 21 2015 Douglas Eadline <deadline@basement-supercomputing.com>
- added auto setting for turbo mode in limulus-node-temp
- added /etc/limfanctl/limfanctl.conf functionality for limulus-node-temp
* Fri Dec 4 2015 Douglas Eadline <deadline@basement-supercomputing.com>
- added option for mulitple fancontrol files based on supported MBs
- added governor scripts, host turbo scrips
* Fri Feb 20 2015 Douglas Eadline <deadline@basement-supercomputing.com>
- added Limulus node-turbo-off/on/status scripts
* Wed Jan 28 2015  Douglas Eadline <deadline@basement-supercomputing.com>
- added Limulus fancontrol files (limfanctl, fancontrol, limulus-node-temps)
* Sun Jan 06 2013  Douglas Eadline <deadline@basement-supercomputing.com>
- added report-ganglia-temp to cron.d to collect temp (copied to nodes throught WW)
- added shutdown-nodes init script to ensure nodes with HDD shutdown properly
* Tue Jul 24 2012  Douglas Eadline <deadline@basement-supercomputing.com>
- created
